---
title: 'TypeError: invalid Array.prototype.sort argument'
slug: Web/JavaScript/Reference/Errors/Array_sort_argument
tags:
  - Error
  - Errors
  - JavaScript
  - TypeError
---
<div>{{jsSidebar("Errors")}}</div>

<p>The JavaScript exception "invalid Array.prototype.sort argument" occurs when the argument of {{jsxref("Array.prototype.sort()")}} isn't either {{jsxref("undefined")}} or a function which compares its operands.</p>

<h2 id="Message">Message</h2>

<pre class="syntaxbox">TypeError: argument is not a function object (Edge)
TypeError: invalid Array.prototype.sort argument (Firefox)
</pre>

<h2 id="Error_type">Error type</h2>

<p>{{jsxref("TypeError")}}</p>

<h2 id="What_went_wrong">What went wrong?</h2>

<p>The argument of {{jsxref("Array.prototype.sort()")}} is expected to be either {{jsxref("undefined")}} or a function which compares its operands.</p>

<h2 id="Examples">Examples</h2>

<h3 id="Invalid_cases">Invalid cases</h3>

<pre class="brush: js example-bad">[1, 3, 2].sort(5);  // TypeError

var cmp = { asc: (x, y) =&gt; x &gt;= y, dsc: (x, y) =&gt; x &lt;= y };
[1, 3, 2].sort(cmp[this.key] || 'asc');  // TypeError
</pre>

<h3 id="Valid_cases">Valid cases</h3>

<pre class="brush: js example-good">[1, 3, 2].sort();   // [1, 2, 3]

var cmp = { asc: (x, y) =&gt; x &gt;= y, dsc: (x, y) =&gt; x &lt;= y };
[1, 3, 2].sort(cmp[this.key || 'asc']); // [1, 2, 3]</pre>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{jsxref("Array.prototype.sort()")}}</li>
</ul>
